# DataType

Extends \ProjectComponent

Base class for those classes that can appear inside the build file as stand alone data types.

This class handles the common description attribute and provides a default implementation for reference handling and checking for circular references that is appropriate for types that can not be nested inside elements of the same type (i.e. patternset but not path)

package | phing.types

### Methods

## Creates an exception that indicates the user has generated a loop of data types referencing each other.

    circularReference() : \BuildException

### Response

`\BuildException`

## Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    dieOnCircularReference( &$stk, \Project $p) : void

If one is included, throw a BuildException created by circularReference

This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

The general contract of this method is that it shouldn't do anything if checked is true and set it to true on exit.

throws |

### Arguments

#### $stk

``

#### $p

`\Project`

## Performs the check for circular references and returns the referenced object.

    getCheckedRef( $requiredClass,  $dataTypeName) : mixed

throws |

### Arguments

#### $requiredClass

``

#### $dataTypeName

``

### Response

`mixed`

## Return the description for the current data type.

    getDescription()

retujrn | string

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Has the refid attribute of this element been set?

    isReference() : boolean

### Response

`boolean`

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.

    noChildrenAllowed() : \BuildException

### Response

`\BuildException`

## Template method being called when the data type has been parsed completely.

    parsingComplete() : void

{@inheritdoc}

## Sets a description of the current data type. It will be useful in commenting what we are doing.

    setDescription(string $desc) : void

### Arguments

#### $desc

`string`

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Set the value of the refid attribute.

    setRefid(\Reference $r) : void

Subclasses may need to check whether any other attributes have been set as well or child elements have been created and thus override this method. if they do they must call parent::setRefid()

### Arguments

#### $r

`\Reference`

## Creates an exception that indicates that refid has to be the only attribute if it is set.

    tooManyAttributes() : \BuildException

### Response

`\BuildException`

### Properties

## The descriptin the user has set.

    description : string

var |

### Type(s)

`string`

## Value to the refid attribute.

    ref : \Reference

var |

### Type(s)

`\Reference`

## Are we sure we don't hold circular references?

    checked : boolean

Subclasses are responsible for setting this value to false if we'd need to investigate this condition (usually because a child element has been added that is a subclass of DataType).

var |

### Type(s)

`boolean`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`